package com.lideeyunji.service.system.service;

import com.lideeyunji.tool.framework.common.pojo.PageResult;
import com.lideeyunji.service.system.controller.vo.dept.rank.RankPageReqVO;
import com.lideeyunji.service.system.controller.vo.dept.rank.RankSaveReqVO;
import com.lideeyunji.service.system.entity.RankDO;
import org.springframework.lang.Nullable;

import java.util.Collection;
import java.util.List;

/**
 * 职级 Service 接口
 *
 * @author 金灯剑客
 */
public interface IRankService {

    /**
     * 创建职级
     *
     * @param createReqVO 职级信息
     * @return 职级编号
     */
    Long createRank(RankSaveReqVO createReqVO);

    /**
     * 更新职级
     *
     * @param updateReqVO 职级信息
     */
    void updateRank(RankSaveReqVO updateReqVO);

    /**
     * 删除职级信息
     *
     * @param id 职级编号
     */
    void deleteRank(Long id);

    /**
     * 获得职级列表
     *
     * @param ids 职级编号数组
     * @return 部门列表
     */
    List<RankDO> getRankList(@Nullable Collection<Long> ids);
    List<RankDO> getRankList();

    /**
     * 获得符合条件的职级列表
     *
     * @param ids 职级编号数组。如果为空，不进行筛选
     * @param statuses 状态数组。如果为空，不进行筛选
     * @return 部门列表
     */
    List<RankDO> getRankList(@Nullable Collection<Long> ids,
                                     @Nullable Collection<Integer> statuses);

    /**
     * 获得职级分页列表
     *
     * @param reqVO 分页条件
     * @return 部门分页列表
     */
    PageResult<RankDO> getRankPage(RankPageReqVO reqVO);

    /**
     * 获得职级信息
     *
     * @param id 职级编号
     * @return 职级信息
     */
    RankDO getRank(Long id);

    /**
     * 校验职级们是否有效。如下情况，视为无效：
     * 1. 职级编号不存在
     * 2. 职级被禁用
     *
     * @param ids 职级编号数组
     */
    void validateRankList(Collection<Long> ids);

}
